package com.example;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;

public class App {
    public static void main(String[] args) throws IOException {
        String filenamein = new String();
        String filenameto = new String();
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        System.out.println("please enter the parent dir");
        filenamein = br.readLine();
        System.out.println("please enter the child dir");
        filenameto = br.readLine();
        File src = new File(filenamein);
        File des = new File(filenameto);
        try {
            if(des.mkdirs())
            {
                System.out.println("this child path is not a extented path but we still creat it to run");
                System.out.println("if it is not the one you wanna please del it later");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        copy(src, des);
        System.out.println("copy successfully!");

    }

    public static void copy(File src, File des) {
        File[] fileArray = src.listFiles();
        if(fileArray != null) {
            for(File src1 : fileArray) {
                File des1 = new File(des, src1.getName());
                if(src1.isDirectory()) {
                    des1.mkdir();
                    copy(src1, des1);//是文件夹则递归
                }else {
                    write(src1, des1);
                }
            }
        }
    }

    public static void write(File src, File des) {
        FileInputStream fis = null;
        FileOutputStream fos = null;
        try {
            fis = new FileInputStream(src);
            fos = new FileOutputStream(des);
            byte[] bys = new byte[1024];
            int len = 0;
            while((len = fis.read(bys)) != -1) {
                fos.write(bys, 0, len);
            }
        }catch(FileNotFoundException e) {
            e.printStackTrace();
        }catch(IOException e){
            e.printStackTrace();
        }finally {
            try {
                fis.close();
                fos.close();
            }catch(IOException e){
                e.printStackTrace();
            }
        }
    }
}

//函数解析
//listFile() return a file list point to this dir
//getname return real path of a absolute name
//mkdir make a dir in this name